#ifndef AK_EVAL_H
#define AK_EVAL_H

#include "cap.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
  * Signature of the callback routine.
  *
  * @param op             GR<= op <= NEQ
  * @param attrInfo       attr/value pair 
  * @param state          optional 
  *
  * @see getType(const AttrInfo)
  * @see getAttr(const AttrInfo)
  * @see getVal(const AttrInfo)
  *
  * @return 1 if successful
  *         0 otherwise
  */
typedef int (*EvalCallBack)(ExprToken op, 
                            const AttrInfo attrInfo, 
                            void* state); 
/**
  * Traverses the expression in <i>CondActions</i> and calls 
  * <i>func<i> with the arguments.
  * 
  * @param constraint to be evaluated
  * @param func  a callback function  
  * @param state optional argument
  *
  * @return 1 if successful
  */
int CondAct_evaluate(const CondActions condActions, EvalCallBack func, void* state);

#ifdef __cplusplus
}
#endif

#endif /* AK_EVAL_H */
