#include "AkentiCertGenerator.hpp"

namespace Akenti {

typedef AkentiCertGenerator ACG;

ACG::AkentiCertGenerator(AkentiCertificateImpl* impl) 
  : akentiCert(impl) {
}

ACG::~AkentiCertGenerator() {
}

void 
ACG::setVersionNumber(int version) {
  akentiCert->setVersionNumber(version);
}

void
ACG::setUniqueID(const string& id) {
  akentiCert->setUniqueID(id);
}


void
ACG::setIssuer(const AkentiIssuer& issuer) {
  akentiCert->setIssuer(issuer);
}

void
ACG::setNotBefore(const UtcTime& utctime) {
  akentiCert->setNotBefore(utctime);
}

void
ACG::setNotAfter(const UtcTime& utctime) {
  akentiCert->setNotAfter(utctime);
}

void 
ACG::sign(const PrivateKey &privateKey, const string& sigalg) {
  akentiCert->sign(sigalg, privateKey);
}

const Akenti::AkentiCertificate&
ACG::generate() {
  return akentiCert;
}

}
