#include "CacheCertGenerator.hpp"
#include "CacheCertificateImpl.hpp"

namespace Akenti {

typedef CacheCertGenerator CCG;

CCG::CacheCertGenerator() 
  : AkentiCertGenerator(new CacheCertificateImpl) {
}

CCG::~CacheCertGenerator() {
}

void 
CCG::setAKCertHolders(const vector<AKCertHolder>& holders) {
  CacheCertificateImpl* 
    impl = (CacheCertificateImpl*) akentiCert.get();

  impl->setAKCertHolders(holders);
}

const CacheCertificate&
CCG::generate() {
  return (const CacheCertificate&) akentiCert;
}

}
