#include "UseCondCertGenerator.hpp"
#include "UseCondCertificateImpl.hpp"
#include "Condition.hpp"

namespace Akenti {

typedef UseCondCertGenerator UCCG;

UCCG::UseCondCertGenerator() 
  : AkentiCertGenerator(new UseCondCertificateImpl) {
}

UCCG::~UseCondCertGenerator() {
}

void
UCCG::setResource(const string& resource) {
  UseCondCertificateImpl* 
    impl = (UseCondCertificateImpl *) akentiCert.get();

  impl->setResource(resource);
}

void 
UCCG::setLocalScope(bool isScopeLocal) {
  UseCondCertificateImpl* 
    impl = (UseCondCertificateImpl *) akentiCert.get();
  
  impl->setLocalScope(isScopeLocal);
}

void 
UCCG::setCritical(bool isCritical) {
  UseCondCertificateImpl* 
    impl = (UseCondCertificateImpl *) akentiCert.get();

  impl->setCritical(isCritical);
}

void 
UCCG::setCondition(const Condition& condition) {
  UseCondCertificateImpl* 
    impl = (UseCondCertificateImpl *) akentiCert.get();

  impl->setCondition(condition);
}

void 
UCCG::setActions(const vector<string>& actions) {
  UseCondCertificateImpl* 
    impl = (UseCondCertificateImpl *) akentiCert.get();

  impl->setActions(actions);
}

}
