#ifndef EXPRESSION_SCANNER_HPP
#define EXPRESSION_SCANNER_HPP

#if defined __GNUC__ && __GNUC__ < 3
# include <map.h>
# include <vector.h>
#else
# include <map>
# include <vector>
#endif 

#include <string>
#include "TokenType.hpp" 

using std::string;
using std::map;
using std::vector;

using namespace Akenti;

namespace Akenti {

/**
  * <i>ExpressionScanner</i>
  *
  * @version 1.1 00/05/01
  * @author Srilekha Mudumbai
  * @author Abdelilah Essiari
  **/

class ExpressionScanner {

public:

  /**
    * Default Constructor.
    */
  ExpressionScanner();

  /**
    * Default Destructor.
    */
  ~ExpressionScanner();

  /**
    *
    */
  void tokenize(const string& expression);

  /**
    *
    */
  TokenType getTokenType() const;

  /**
    *
    **/
  bool hasMoreTokens() const;

  /**
    *
    **/
  TokenType peek() const;

  /**
    *
    */
  void nextToken();

  /**
    *
    */
  const string& getLexeme() const;

  /**
    *
    */
  void listTokens() const;

private:

  int index;

  string lexeme;

  vector<string> tokens;

};

} // end of namespace

#endif
