#include "OutputStream.hpp"
#include "InputStream.hpp"
#include "CacheResponse.hpp"
#include "Error.hpp"


typedef CacheResponse CR;

CR::CacheResponse() : status("NO_STATUS") {
}

CR::CacheResponse(const string& method) 
  : CacheRequest(method), status("NO_STATUS") {
}

CR::~CacheResponse() {
}

void 
CR::setStatus(const string& status) {
  if (!status.length()) {
    throw Error("CacheResponse:setStatus:illegal arg");
  }
  
  this->status = status;
}

const string& 
CR::getStatus() const {
  return status;
}

void 
CR::writeHeaderInfo(OutputStream& os) const {
  CacheRequest::writeHeaderInfo(os);
  os << "STATUS: " << status << '\n';
}

void 
CR::readHeaderInfo(InputStream& is) {
  CacheRequest::readHeaderInfo(is);
  status = parse("STATUS", readLine(is));
}
