#ifndef AKENTI_FILE_EXTERNAL_CACHE_IMPL_HPP
#define AKENTI_FILE_EXTERNAL_CACHE_IMPL_HPP

#include "ExternalCacheImpl.hpp"

namespace Akenti {

/**
  * <i>FileExternalCacheImpl</i> 
  *
  * @see AkentiCertificate
  *
  * @version 1.1 00/05/01
  * @author Srilekha Mudumbai
  * @author Abdelilah Essiari
  */
class FileExternalCacheImpl : public ExternalCacheImpl {
  
public:

  /**
    *
    */
  FileExternalCacheImpl();

  /**
    *
    */
  ~FileExternalCacheImpl();

  /**
    *
    */
  bool openConnection();

  /**
    *
    */
  bool
  storeCacheCertificate(const string& rootResourceName, 
                        const CacheCertificate& cert,
                        const string& dirName);

  /**
    *
    */
  CacheCertificate
  retrieveCacheCertificate(const string& rootResourceName, 
                           const string& key,
                           const string& dirName); 
  /**
    *
    */
  bool flushCacheCertificates(const string& rootResourceName,
                              const string& key,
                              const string& dirName);
  /**
    *
    */
  bool closeConnection();

protected:

  virtual string 
  createResourceDirectory(const string& resource);

  virtual string createCacheDirectory();
  
private:
  
  string cacheDirectory;

};

} // end of name space

#endif
