#include <sstream> 
#include "CertInfo.hpp"
#include "CertInfoCollector.hpp"

#include <iostream>
using namespace std;

typedef CertInfoCollector CIC ;

namespace Akenti {

CIC::CertInfoCollector() {
  didItWork = true;
}

CIC::~CertInfoCollector() {
}

const vector<CertInfo>& 
CIC::getCertInfoVec() {
  return certInfoList;
}

void
CIC::reorderCertInfoVec () {
   vector <CertInfo>  certInfoVec;

   for (int j = 0; j < certInfoList.size(); ++j) {
      CertInfo&  cinfo = (CertInfo &) certInfoList[j];
      string resource;

      if (cinfo.getType() == "dummy")  {
         certInfoVec.push_back(cinfo);
      }
      else if (cinfo.getType() == "Policy") {
         certInfoVec.push_back(cinfo);
         resource = cinfo.getResource();

         for (int i = j; i <certInfoList.size();  ++i) {
            CertInfo& cinfoUC = (CertInfo &)certInfoList[i];
            if ((cinfoUC.getResource() == resource) &&
                (cinfoUC.getType() == "Use Condition")) {
               certInfoVec.push_back(cinfoUC);
            }
         }
      }
   }

   certInfoList = certInfoVec;
}

void 
CIC::addCertInfo(const CertInfo& cinfo) {
  certInfoList.push_back (cinfo);
}

CertInfo&
CIC::getCertInfo (int index) {
   return certInfoList[index];
}

CertInfoCollector*
CIC::createCertInfoCollector() {
   return new CertInfoCollector;
}

void 
CIC::setStatus (bool errorVal) {
   didItWork = errorVal;
}

bool
CIC::getStatus () {
   return didItWork;
}

void
CIC::addMessage (int index, AkentiMessage mesg) {
  certInfoList[index].addMessage (mesg);
}

void
CIC::setUsed (int index, bool usedVal) {
  certInfoList[index].setUsed (usedVal);
}

void
CIC::setError (int index, bool err) {
  certInfoList[index].setError (err);
}


int
CIC::lookup (string hcode, string type) {
   for (int i = 0; i < certInfoList.size(); ++i) {
       if (certInfoList[i].getHashCode() != "dummy") {
          if ((hcode == certInfoList[i].getHashCode()) &&
              (type == certInfoList[i].getType())) {
              return i;
          }
       }
   }
   return -1;
}

int
CIC::lookup (string hcode, string type, string uid) {
   for (int i = 0; i < certInfoList.size(); ++i) {
       if (certInfoList[i].getHashCode() != "dummy") {
          if ((hcode == certInfoList[i].getHashCode()) &&
              (type == certInfoList[i].getType()) &&
              (uid == certInfoList[i].getCertificate().get()->getUniqueID())) {
              return i;
          }
       }
   }
   return -1;
}
}
