#ifndef AKENTI_GET_RESOURCE_INFO_REQUEST_HPP
#define AKENTI_GET_RESOURCE_INFO_REQUEST_HPP

#include "AkentiRequest.hpp"

namespace Akenti {

/**
  * @see AkentiRequest
  */
class GetResourceInfoRequest : public AkentiRequest {
 
public:

  /**
    * Constructor
    */
  GetResourceInfoRequest();

  /**
    * Sets the resource whose info we want retreive.
    */
  void setResource(const string& resource);

  /**
    * Extracts the resource whose info we wish to get.
    */
  const string& getResource() const;

private:

  friend class AkentiRequest;
  friend class AkentiRequestResponseImplFactory;
  static AkentiRequestImpl* getRequestImpl(); 
  class GetResourceInfoRequestImpl;
  typedef GetResourceInfoRequestImpl* ImplType; 

};

}

#endif
