#ifndef AKENTI_HTTP_REQUEST_HPP
#define AKENTI_HTTP_REQUEST_HPP

#include <string>
#include "HttpBase.hpp"

using std::string;

namespace Akenti {

/**
  *
  * @version 1.1 12/26/02
  * @author Abdelilah Essiari 
  */	

class HttpRequest : public HttpBase {

public:

  /**
    */
  HttpRequest();

  /**
    */
  ~HttpRequest();

  /**
    */
  void setMethod(const string& method);

  /**
    */
  const string& getMethod() const;

  /**
    */
  void setURI(const string& uri);

  /**
    */
  const string& getURI() const;

  /**
    */
  InputStream getInputStream() const;

  /**
    */
  OutputStream getOutputStream();

  /**
    */
  void fromStream(InputStream& is);

  /**
    */
  void toStream(OutputStream& os) const;

private:

  string uri;

  string method;

};

} // end of name space

#endif
