#ifndef AK_FILE_URL_HANDLER_IMPL_HPP
#define AK_FILE_URL_HANDLER_IMPL_HPP

#include "URLHandlerImpl.hpp"

/**
  * A <i>FileURLHandlerImpl<i> is an object that implements the services for  
  * a file URL that are provided by the base class, URLHandlerImpl. 
  * It initializes a file URL by parsing
  * the a URL string. It creates the URL string from the URL.
  * It creates a URL connection for the file. 
  *
  * @see URL 
  * @see URLConnection
  *
  * @version 1.1 00/11/01
  * @author Srilekha Mudumbai
  * @author Abdelilah Essiari
  */

namespace Akenti {

class FileURLHandlerImpl : public URLHandlerImpl {

public:

  /**
    * Constructs this object.   
    */
  FileURLHandlerImpl();

  /**
    * Destroys this object
    */
  ~FileURLHandlerImpl();

  /**
    * Creates a new URL connection and returns it.
    *
    * @param url The URL to which the connection is going to apply
    * @return URLConnection a new URL connection  
    * @see URLConnection#URLConnection(URLConnectionImpl* impl = NULL)
    * @see FileURLConnectionImpl(const URL& url)    
    */
  URLConnection getURLConnection(const URL& url) const;

};

} // end of namespace Akenti

#endif
