#include "URLHandlerFactory.hpp"

using Akenti::URLHandlerFactory;

typedef URLHandlerFactory UHF;

URLHandlerFactory UHF::fac = URLHandlerFactory();

UHF::URLHandlerFactory(URLHandlerFactoryImpl* impl) 
  : ref_ptr<URLHandlerFactoryImpl> (impl) {
  
  if (!impl) {
    throw Error("URLHandlerFactory:constructor:illegal argument");
  }
}

UHF::~URLHandlerFactory() {
}

void 
UHF::setURLHandlerFactory(const URLHandlerFactory& fact) {
  URLHandlerFactory::fac = fact;
}

const URLHandlerFactory&
UHF::getURLHandlerFactory() {
  return fac;
}
