#ifndef OPEN_SSL_HMAC_IMPL_HPP
#define OPEN_SSL_HMAC_IMPL_HPP

#include "HmacImpl.hpp" 
#include "openssl/hmac.h"

namespace Akenti {

/**
  * @see HmacImpl 
  * @see Hmac 
  *
  * @author Abdelilah Essiari
  */
class OpenSSLHmacImpl : public HmacImpl {

public:

  /**
    */
  OpenSSLHmacImpl(const string& alg);

  /**
    * Destroys this engine.
    */
  ~OpenSSLHmacImpl();

  /**
    */
  int getSize() const;

private:

  /**
    */
  string doDigest(); 
  
  /**
    */
  void resetEngine();

  /**
    */
  void doUpdate(const string& data, int offset, int len);
  
  /**
    */
  HMAC_CTX ctx;
  
};

}

#endif
