#include <string>
#include <map>
#include "Properties.hpp"
#include "StringTokenizer.hpp"
#include "Exception.hpp"
#include "Error.hpp"
#include "ParseResourceUtil.hpp"

using namespace std;

namespace Akenti {

  typedef ParseResourceUtil PRU;

  bool 
  PRU::parseResource(const string& resource, vector<string>& resources) {
    StringTokenizer st(resource, "/ ", true);
    bool ret = false;
    string name;

    while (st.hasMoreTokens()) {
      string temp = st.nextToken();

      if (temp == "/" || temp == " ") {
	break;
      }

      resources.push_back(name += temp);
      ret = true;

      if (!st.hasMoreTokens()) {
	break;
      }

      if (st.nextToken() == " ") {
	ret = false;
	break;
      }

      name += "/";
      ret = false;
    }

    return ret;
  }

}
