#ifndef POLICY_CERT_GENERATOR_TEST_CASE_HPP
#define POLICY_CERT_GENERATOR_TEST_CASE_HPP

#include "cppunit/TestSuite.h"
#include "cppunit/TestCase.h"

/**
  * Generates the policy certificates for the Akenti test.
  */
class PolicyCertGeneratorTestCase : public CppUnit::TestCase {

public:

  /**
    * Constructs this object.
    */
  PolicyCertGeneratorTestCase(const std::string& name = "PolicyCertGeneratorTestCase")
    : TestCase (name) {
  }

  /**
    * Registers the <i>generatePolicyCerts</i>.
    */
  static CppUnit::TestSuite* suite();

private:

  /**
    * Generates all the policy certificates used by
    * the akenti Test.
    */
  void generatePolicyCerts();

  /**
    */
  void generateROOT1PolicyCert();  

  /**
    */
  void generateROOT2PolicyCert();

  /**
    */
  void generateSUB1PolicyCert();

  /**
    */
  void generateSUB3PolicyCert();

  /**
    */
  void generateSUB4PolicyCert(); 

  /**
    */
  void generateROOT3PolicyCert();  

  /**
    */
  void generateROOT4PolicyCert();  

};

#endif

