#include <iostream>
#include "cppunit/TextTestRunner.h"
#include "Provider.hpp"
#include "OpenSSLProviderImpl.hpp"
#include "ElementsTestCase.hpp" 	
#include "Exception.hpp"
#include "Error.hpp"

using namespace Akenti;
using namespace std;

int
main(int ac, char **argv) {
  try {
    Provider p = Provider(new OpenSSLProviderImpl);
    Provider::setProvider(p);
    CppUnit::TextTestRunner runner;

    runner.addTest(ElementsTestCase::suite());
    runner.run("", false);
    return 0;   
  } catch(Exception& ex) {
    cout << "TestElements:main:" << ex << endl;
  } catch(Error& err) {
    cout << "TestElements:main:" << err << endl;
  }

  return 1;
}
