#include "cppunit/TestCaller.h"
#include "cppunit/Exception.h"
#include "cppunit/SourceLine.h"
#include "cppunit/Message.h"
#include "ExpressionTestCase.hpp"
#include "Expression.hpp"
#include "Exception.hpp"
#include "Error.hpp"
#include <iostream>

using namespace Akenti;
using namespace std;

typedef ExpressionTestCase ETC; 

void 
ETC::doTest() {
  string method;

  try {
    method = "ExpressionTestCase:parseExpressions:";
    parseExpressions();
    method = "ExpressionTestCase:evaluateExpression:";
    evaluateExpression();
    method = "ExpressionTestCase:visitExpression:";
    visitExpression();
  } catch(Exception& ex) {
    CppUnit::Message m(method + ex.getMessage());

    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  } catch(Error& err) {
    CppUnit::Message m(method + err.getMessage());

    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  }
}

void
ETC::parseExpressions() {
#if DEBUG 
  cout << "\nBEGIN parseExpressions" << endl;
#endif

  Expression expr1 = Expression("a1 != 1");
  Expression expr2 = Expression("a1>=1||a2<2&&!a3=3");

#if DEBUG 
  cout << "ParseedExpression = " << expr1.toString() << endl;
  cout << "ParseedExpression = " << expr2.toString() << endl;
  cout << "END parseExpressions" << endl;
#endif
}

void
ETC::evaluateExpression() {
}

void
ETC::visitExpression() {
}

CppUnit::TestSuite*
ETC::suite() {
  CppUnit::TestSuite* testSuite = new CppUnit::TestSuite("ExpressionTestCase");

  testSuite->addTest(
    new CppUnit::TestCaller<ExpressionTestCase>(
      "doTest", &ExpressionTestCase::doTest
    )
  );

  return testSuite;
}
