#ifndef EXPRESSION_TEST_CASE_HPP 
#define EXPRESSION_TEST_CASE_HPP

#include "cppunit/TestSuite.h"
#include "cppunit/TestCase.h"

/**
  * Tests parsing and traversing <i>Expression</i>s.
  */
class ExpressionTestCase : public CppUnit::TestCase {

public:

  /**
    * Constructs this <i>TestCase</i>.
    */
  ExpressionTestCase(const std::string& name = "ExpressionTestCase")
    : TestCase (name) {
  }

  /**
    * Registers the <i>doTest</i> method.
    */
  static CppUnit::TestSuite* suite();

private:

  /**
    * Calls parseExpressions, evaluateExpression, and visitExpression.
    */
  void doTest();

  /**
    * Parses expressions.
    */
  void parseExpressions(); 

  /**
    * Tests the <i>ExpressionEvaluator<i> traversal.
    */
  void evaluateExpression(); 

  /**
    * Tests the <i>ExpressionVisitor<i> traversal.
    */
  void visitExpression(); 

};

#endif

