#include <fstream>
#include <iostream>
#include <sstream>
#include "cppunit/Exception.h"
#include "cppunit/TestCaller.h"
#include "cppunit/Message.h"
#include "cppunit/SourceLine.h"
#include "Exception.hpp"
#include "Error.hpp"
#include "Xerces-Includes.hpp"
#include "XMLUtil.hpp"
#include "CreateResourceResponseTestCase.hpp"
#include "CreateResourceResponse.hpp"
#include "AkentiResponses.hpp"

using namespace std;

typedef CreateResourceResponseTestCase CRRTC;

void 
CRRTC::doTest() {
  string method;

  try {
    method = "CreateResourceResponseTestCase:doTest:test1:";
    test1();
  } catch (Exception& ex) {
    CppUnit::Message m(method + ex.getMessage());

    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  } catch (Error& err) {
    CppUnit::Message m(method + err.getMessage());

    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  }
}

void
CRRTC::test1() {
#if DEBUG
  cout << "Entering test1! ..." << endl;
#endif

  AkentiResponses resps;
  CreateResourceResponse resp;

  resps.addResponse(resp);

  DOMElement* element = resps.toXML();

#if DEBUG
  XMLUtil::write(cout, element);
#endif
  
  resps.fromXML(element);
  delete(element->getOwnerDocument());

#if DEBUG
  CPPUNIT_ASSERT(resps.numOfResponses() == 1);
  cout << "Exiting test1! ..." << endl;
#endif
}

CppUnit::TestSuite*
CRRTC::suite() {
  CppUnit::TestSuite* testSuite = new CppUnit::TestSuite("CreateResourceResponseTestCase");

  testSuite->addTest (
    new CppUnit::TestCaller<CreateResourceResponseTestCase> ( 
      "doTest", 
      &CreateResourceResponseTestCase::doTest
    )
  );

  return testSuite;
}
