#include <iostream>
#include "cppunit/Exception.h"
#include "cppunit/TestCaller.h"
#include "cppunit/Message.h"
#include "cppunit/SourceLine.h"
#include "Exception.hpp"
#include "Error.hpp"
#include "Xerces-Includes.hpp"
#include "XMLUtil.hpp"
#include "DeleteCertificateRequestTestCase.hpp"
#include "DeletePolicyCertificateRequest.hpp"
#include "AkentiRequests.hpp"

using namespace std;

typedef DeleteCertificateRequestTestCase DCRTC;

void 
DCRTC::doTest() {
  string method;

  try {
    method = "DeleteCertificateRequestTestCase:doTest:test1:";
    test1();
  } catch (Exception& ex) {
    CppUnit::Message m(method + ex.getMessage());

    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  } catch (Error& err) {
    CppUnit::Message m(method + err.getMessage());

    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  }
}

void
DCRTC::test1() {
#if DEBUG
  cout << "Entering test1 ..." << endl;
#endif

  DeletePolicyCertificateRequest dcr;
  string resource = "R1";

  dcr.setResource(resource);
  CPPUNIT_ASSERT(resource == dcr.getResource());

  AkentiRequests reqs;

  reqs.addRequest(dcr);

#if DEBUG
  cout << reqs.toString() << endl;
#endif

  DOMElement* element = reqs.toXML(); 

  reqs.fromXML(element);
  dcr = (DeletePolicyCertificateRequest&) reqs.getRequestAt(0);
  CPPUNIT_ASSERT(resource == dcr.getResource());

#if DEBUG
  cout << "Exiting test1" << endl;
#endif
}

CppUnit::TestSuite*
DCRTC::suite() {
  CppUnit::TestSuite* testSuite = new CppUnit::TestSuite("CollectPolicyResponseTestCase");

  testSuite->addTest (
    new CppUnit::TestCaller<DeleteCertificateRequestTestCase> ( 
      "doTest", 
      &DeleteCertificateRequestTestCase::doTest
    )
  );

  return testSuite;
}
