#include <iostream>
#include "cppunit/TestCaller.h"
#include "cppunit/Exception.h"
#include "cppunit/Message.h"
#include "cppunit/SourceLine.h"
#include "DeleteCertificateResponseTestCase.hpp"
#include "DeletePolicyCertificateResponse.hpp"
#include "AkentiResponses.hpp"
#include "Xerces-Includes.hpp"
#include "Exception.hpp"
#include "Error.hpp"

using namespace std;
using namespace Akenti;

typedef DeleteCertificateResponseTestCase DCRTC;

void 
DCRTC::doTest() {
  string method;

  try {
    method = "DeleteCertificateResponseTestCase:doTest:test1:";
    test1();
  } catch (Exception& ex) {
    CppUnit::Message m(method + ex.getMessage());

    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  } catch (Error& err) {
    CppUnit::Message m(method + err.getMessage());

    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  }
}

void
DCRTC::test1() {
#if DEBUG
  cout << "Entering test1! ..." << endl;
#endif

  DeletePolicyCertificateResponse ucr;

  ucr.setID(1);

  AkentiResponses resps;

  resps.addResponse(ucr);

#if DEBUG
  cout << resps << endl;
#endif

  DOMElement* element = resps.toXML();

  resps.fromXML(element);
  delete(element->getOwnerDocument());
  ucr = (DeletePolicyCertificateResponse&) resps.getResponseAt(0);

#if DEBUG
  cout << "\nExiting test1 ..." << endl;
#endif
}

CppUnit::TestSuite*
DCRTC::suite() {
  CppUnit::TestSuite* testSuite = new CppUnit::TestSuite("DeleteCertificateResponseTestCase");

  testSuite->addTest (
    new CppUnit::TestCaller<DeleteCertificateResponseTestCase> ( 
      "doTest", 
      &DeleteCertificateResponseTestCase::doTest
    )
  );

  return testSuite;
}
