#include <iostream>
#include "cppunit/Exception.h"
#include "cppunit/TestCaller.h"
#include "cppunit/Message.h"
#include "cppunit/SourceLine.h"
#include "Xerces-Includes.hpp"
#include "XMLUtil.hpp"
#include "UploadCertificateResponseTestCase.hpp"
#include "UploadPolicyCertificateResponse.hpp"
#include "AkentiResponses.hpp"
#include "Exception.hpp"
#include "Error.hpp"

using namespace std;

typedef UploadCertificateResponseTestCase CRRTC;

void 
CRRTC::doTest() {
  string method;

  try {
    method = "UploadCertificateResponseTestCase:doTest:test1:";
    test1();
  } catch (Exception& ex) {
    CppUnit::Message m(method + ex.getMessage());

    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  } catch (Error& err) {
    CppUnit::Message m(method + err.getMessage());

    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  }
}

void
CRRTC::test1() {
#if DEBUG
  cout << "Entering test1! ..." << endl;
#endif
  UploadPolicyCertificateResponse ucr;
  AkentiResponses resps;

  resps.addResponse(ucr);
  DOMElement* element = resps.toXML(); 

  resps.fromXML(element);
  delete(element->getOwnerDocument());
  CPPUNIT_ASSERT(resps.numOfResponses() == 1);
#if DEBUG
  cout << "\nExiting test1 ..." << endl;
#endif
}

CppUnit::TestSuite*
CRRTC::suite() {
  CppUnit::TestSuite* testSuite = new CppUnit::TestSuite("UploadCertificateResponseTestCase");

  testSuite->addTest (
    new CppUnit::TestCaller<UploadCertificateResponseTestCase> ( 
      "doTest", 
      &UploadCertificateResponseTestCase::doTest
    )
  );

  return testSuite;
}
