#ifndef CREATE_AKENTI_CONF_HPP  
#define CREATE_AKENTI_CONF_HPP  

#include "cppunit/TestSuite.h"
#include "cppunit/TestCase.h"

/**
  * Creates the Akenti configuration file for the Akenti test.
  */
class CreateAkentiConf : public CppUnit::TestCase {

public:

  /**
    * Constructor.
    */
  CreateAkentiConf(const std::string& name = "CreateAkentiConf"): 
    TestCase(name) {
  } 

  /**
    * Regiters the <i>createAkentiConfig</i> method.
    */
  static CppUnit::TestSuite* suite();

private:

  /**
    * Creates configuration file for engine and server.
    *
    */
  void createAkentiConfig(); 

  /**
    * Creates configuration file for a client.
    */
  void createClientConfig(); 

}; 

#endif
