#include "cppunit/Exception.h"
#include "cppunit/TestCaller.h"
#include "cppunit/Message.h"
#include "cppunit/SourceLine.h"
#include "DistinguishedNameTestCase.hpp"
#include "DistinguishedName.hpp"
#include "Exception.hpp"
#include "Error.hpp"

using namespace Akenti;
using namespace std;

void 
DistinguishedNameTestCase::doTest() {
  string method;

  try {
    method = "DistinguishedNameTestCase:test1:";
    test1();
    method = "DistinguishedNameTestCase:test2:";
    test2();
  } catch(Exception& ex) {
    CppUnit::Message m(method + ex.getMessage());
 
    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  } catch(Error& err) {
    CppUnit::Message m(method + err.getMessage());
 
    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  }
}

void
DistinguishedNameTestCase::test1() {   
  DistinguishedName dn("/C=US/CN=John Smith");
  
  // XXX
}

void 
DistinguishedNameTestCase::test2() {
  DistinguishedName dn("/DC=org/DC=DOEGrids/CN=rook/solaris");
  
  // XXX
}

CppUnit::TestSuite*
DistinguishedNameTestCase::suite() {
  CppUnit::TestSuite *testSuite = new CppUnit::TestSuite("DistinguishedNameTestCase");     

  testSuite->addTest(
    new CppUnit::TestCaller<DistinguishedNameTestCase>(
      "doTest",  
      &DistinguishedNameTestCase::doTest
    )
  );       

  return testSuite;
}
