#ifndef SIGNATURE_TEST_CASE_HPP
#define SIGNATURE_TEST_CASE_HPP

#include "cppunit/TestSuite.h"
#include "cppunit/TestCase.h"

class SignatureTestCase : public CppUnit::TestCase {

public:

  /**
    * Constructs this object.
    */
  SignatureTestCase(const std::string& name = "SignatureTestCase") : TestCase(name) {
  }

  /**
    * Registers the <i>doTest</i> method.
    */
  static CppUnit::TestSuite* suite();

private:
  
  /**
    * Calls <i>signatureRSAWithMD5</i> and <i>signatureDSAWithSHA1</i>.
    */
  void doTest();

  /**
    * Generates a RSA key pair, signs some data using MD5, and finally verifies 
    * the signature.
    */
  void signatureRSAWithMD5();

  /**
    * Generates a RSA key pair, signs some data using SHA1, and finally verifies 
    * the signature.
    */
  void signatureDSAWithSHA1();

};

#endif
