#include "Provider.hpp"
#include "DistinguishedName.hpp"
#include "OpenSSLProviderImpl.hpp"
#include "SecurityException.hpp"
#include "CertificateFactory.hpp"
#include "CertificateChain.hpp"
#include <vector>

using namespace Akenti;

int main() {

  try {
    Provider p = Provider(new OpenSSLProviderImpl);

    Provider::setProvider(p);

    CertificateFactory fac = CertificateFactory::getCertificateFactory();
    CertificateChain chain = fac->initCertificateChainFromFile("PEM", "cache.certs");

    vector<Certificate> certs = chain->getCACertificates();

    for (int i=0; i < certs.size(); i++) {
      cout << certs[i]->getGuarantor().toString() << endl;
    }

    vector< pair<string,string> > ignoreparams;

    ignoreparams.push_back(pair<string,string>("CN", "proxy"));
    ignoreparams.push_back(pair<string,string>("CN", "limited proxy"));
    chain->ignoreCertificates(ignoreparams);
    cout << chain->getGuarantor().toString() << endl;
  } catch (Exception &ex) {
    cout << ex.getMessage() << endl;
  } catch (Error& err) {
    cout << "SHLOUD NEVER HAPEN" << err.getMessage() << endl;
  }
}
