#include "OpenSSLPrivateKeyImpl.hpp"

using Akenti::OpenSSLPrivateKeyImpl;

OpenSSLPrivateKeyImpl::OpenSSLPrivateKeyImpl(EVP_PKEY *evp) 
  : OpenSSLKeyImpl(evp) {
}
  
EVP_PKEY*
OpenSSLPrivateKeyImpl::getEVP_PKEY() {
  return evp;
}

OpenSSLPrivateKeyImpl::~OpenSSLPrivateKeyImpl() { 
}

string 
OpenSSLPrivateKeyImpl::getAlgorithm() const {
  return algorithm();
}
  
string 
OpenSSLPrivateKeyImpl::getFormat() const {
  return format();
}

int 
OpenSSLPrivateKeyImpl::getSize() const { 
  return size();
}
  
string 
OpenSSLPrivateKeyImpl::encrypt(const string &data) const {
  return privateEncrypt(data);
}

string 
OpenSSLPrivateKeyImpl::decrypt(const string &encrypted) const {
  return privateDecrypt(encrypted);
}

string 
OpenSSLPrivateKeyImpl::paramString() const {
  string params;

  params = '[';
  params += "format";
  params += '=';
  params += '"';
  params += getFormat();
  params += '"';
  params += ',';
  params += "algorithm";
  params += '=';
  params += '"';
  params += getAlgorithm();
  params += '"';
  params += ',';
  params += "private";
  params += ']';
  return params;
}

